package dev.shadowsoffire.apotheosis.garden;

import dev.shadowsoffire.placebo.recipe.RecipeHelper;
import dev.shadowsoffire.placebo.config.Configuration;
import java.io.File;
import dev.shadowsoffire.placebo.tabs.TabFillingRegistry;
import java.util.function.Supplier;
import net.minecraft.world.item.CreativeModeTabs;
import net.minecraft.world.level.block.ComposterBlock;
import net.minecraft.world.item.Item;
import dev.shadowsoffire.placebo.util.PlaceboUtil;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.Block;
import dev.shadowsoffire.placebo.registry.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import java.util.function.Consumer;
import net.minecraftforge.common.MinecraftForge;
import net.minecraft.world.item.Items;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;

public class GardenModule
{
    public static int maxCactusHeight;
    public static int maxReedHeight;
    public static int maxBambooHeight;
    
    @SubscribeEvent
    public void setup(final FMLCommonSetupEvent e) {
        this.reload(null);
        Apotheosis.HELPER.registerProvider(factory -> factory.addShapeless((Object)Apoth.Items.ENDER_LEAD, new Object[] { "forge:ender_pearls", Items.f_42655_, Items.f_42417_ }));
        MinecraftForge.EVENT_BUS.addListener((Consumer)this::reload);
    }
    
    @SubscribeEvent
    public void blocks(final RegistryEvent.Register<Block> e) {
        PlaceboUtil.registerOverride(Blocks.f_50128_, (Block)new ApothCactusBlock(), "apotheosis");
        PlaceboUtil.registerOverride(Blocks.f_50130_, (Block)new ApothSugarcaneBlock(), "apotheosis");
        PlaceboUtil.registerOverride(Blocks.f_50571_, (Block)new ApothBambooBlock(), "apotheosis");
    }
    
    @SubscribeEvent
    public void items(final RegistryEvent.Register<Item> e) {
        e.getRegistry().register((Object)new EnderLeadItem(), "ender_lead");
        ComposterBlock.f_51914_.put((Object)Blocks.f_50128_.m_5456_(), 0.5f);
        ComposterBlock.f_51914_.put((Object)Blocks.f_50130_.m_5456_(), 0.5f);
        TabFillingRegistry.register(CreativeModeTabs.f_256869_, new Supplier[] { (Supplier)Apoth.Items.ENDER_LEAD });
    }
    
    public void reload(final Apotheosis.ApotheosisReloadEvent e) {
        final Configuration c = new Configuration(new File(Apotheosis.configDir, "garden.cfg"));
        c.setTitle("Apotheosis Garden Module Configuration");
        GardenModule.maxCactusHeight = c.getInt("Cactus Height", "general", GardenModule.maxCactusHeight, 1, 512, "The max height a stack of cacti may grow to.  Vanilla is 3.  Values greater than 32 are uncapped growth.\nServer-authoritative.");
        GardenModule.maxReedHeight = c.getInt("Reed Height", "general", GardenModule.maxReedHeight, 1, 512, "The max height a stack of reeds may grow to.  Vanilla is 3.  Values greater than 32 are uncapped growth.\nServer-authoritative.");
        GardenModule.maxBambooHeight = c.getInt("Bamboo Height", "general", GardenModule.maxBambooHeight, 1, 64, "The max height a stack of bamboo may grow to.  Vanilla is 16.\nServer-authoritative.");
        if (e == null && c.hasChanged()) {
            c.save();
        }
    }
    
    static {
        GardenModule.maxCactusHeight = 5;
        GardenModule.maxReedHeight = 255;
        GardenModule.maxBambooHeight = 32;
    }
}
